<?xml version='1.0' encoding='utf-8'?>
| <!DOCTYPE rfc SYSTEM "rfc2629-xhtml.ent" [
// external reference to RFCs
<!ENTITY rfc2119 SYSTEM "http://xml.resource.org/public/rfc/bibxml/reference.RFC.2119.xml">
// local reference to another doc
| ]>

// processing instructions
<?rfc toc="yes"?>
<?rfc symrefs="yes"?>
<?rfc compact="yes"?>
<?rfc subcompact="no"?>
<?rfc strict="no"?>
<?rfc rfcedstyle="yes"?>
<?rfc comments="yes"?>
<?rfc inline="yes"?>


// categories: std | bcp | info | exp | historic
rfc(category='std' number='2417687' consensus='false' ipr='trust200902' docName='ntof-data-format-01' submissionType='ntof-daq' xml:lang='en' version='3')
  front
    title n_ToF Data Format Specification
    author(fullname='Mathieu Donzé' initials='M.D.' surname='Donzé')
      organization CERN
      address
        postal
          street 1, Esplanade des Particules
          code 1217
          city Meyrin
          country Switzerland
        email mathieu.donze@cern.ch
    author(fullname='Alexandre Giraud' initials='A.G.' surname='Giraud')
      organization CERN
      address
        postal
          street 1, Esplanade des Particules
          code 1217
          city Meyrin
          country Switzerland
    author(fullname='Matteo Ferrari' initials='M.F.' role='editor' surname='Ferrari')
      organization CERN
      address
        postal
          street 1, Esplanade des Particules
          code 1217
          city Meyrin
          country Switzerland
        email matteo.ferrari.1@cern.ch
    date(year='2020' month="January" day="13")

    keyword n_TOF

    abstract
      t This document describes the structure of the data files in the n_TOF experiment.

  middle

    section
      name Introduction
      t
        | This document describes the content of the files generated by the n_TOF experiment.

      // This one is a 'must' :)
      section
        name Requirements Notation
        t
          | The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
          | "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this
          | document are to be interpreted as described in BCP 14,
          | #[xref(target='RFC2119' format='default') RFC2119].

      section
        name Vocabulary, Definitions, Acronyms and Terms
        t Here are some conventions used among this document:
        ul
          li Crate = Chassis
          li Stream = DAQ computer
          li Module = Card
          li Digitizer = Channel
          li Trigger = Event = Bunch
          li Event Number = Id of the event
          li Extension number = Id of the file
          li
            | Movie = All the pulses related to an event. In case the zero suppression
            | is not applied. In case of zero suppression, each single block of data
            | over threshold is a movie (so one event may have more than one movie
            | and each movie might contain more than one pulse).
          li Segment = File

    section
      name Files
      t
        | The n_TOF software produces two main kinds of files. The first kind can be called
        | “local files” and are related to files stored on computer local storage (hard disks). The
        | second category refers to files created on CASTOR by the merger software.

      section
        name Local Files
        t
          | Local files are files existing on DAQ computers hard disks. For performances reasons
          | and to simplify the synchronization between DAQ computers some headers are not
          | completely filled.
          | Basically, three kind of files are used to generate the resulting CASTOR file.

        section
          name DAQ Data Files
          t
            | For each validated trigger, the DAQ computer will create a new data file on local disk.
            | These data files contains a SKIP header followed by a sequence of ACQC headers (one
            | ACQC per channel). The naming convention used will be:
          t
            em /DAQ/data/run#[strong XXXXXX]/run#[strong XXXXXX]_#[strong YYY]_s#[strong ZZ].raw
          t where:
          ul
            li #[strong XXXXXX] is the run number
            li #[strong YYY] is the counter of received triggers since the start of the run
            li #[strong ZZ] is the stream number used to identify the DAQ computer

        section
          name Application Server Metadata Files
          t
            | On the application server, two kinds of files will be created.
            | One file will be created for each run. This file will contain RCTR and MODH headers.
            | The file name will be:
          t
            em /DAQ/data/run#[strong XXXXXX]/run#[strong XXXXXX].run
          t where:
          ul
            li #[strong XXXXXX] is the run number
          t
            | The other file will be created for each validated trigger. It will contains EVEH and
            | ADDH headers.
            | The file name will be:
          t
            em /DAQ/data/run#[strong XXXXXX]/run#[strong XXXXXX]_#[strong YYY].event
          t where:
          ul
            li #[strong XXXXXX] is the run number
            li #[strong YYY] is the counter of received triggers since the start of the run

      section
        name Castor Files

        section
          name Raw Data
          t
            | Raw data files will be produced by the application server using the collection of all files
            | written to machine’s hard disks (through NFS).
            | These files contain all information concerning the run, the channels configuration and
            | the data taken by all the digitizers of a DAQ.

          t
            | The name of the CASTOR raw files is formed like this:
          t
            em /castor/cern.ch/ntof/#[strong YEAR]/#[strong EAR]/#[strong EXP]/#[strong XXXXXX]/stream
              | #[strong S]/run#[strong XXXXXX]_#[strong YYY]_s#[strong S].raw.finished
          t where:
          ul
            li #[strong YEAR] Year of the start of the run on four digit
            li #[strong EAR] Experimental area (ear1 or ear2)
            li #[strong EXP] Experiment name
            li #[strong S] Stream number (1)
            li #[strong XXXXXX] is the run number
            li #[strong YYY] is the segment number (incremental)

          t The internal organization of the file:
          ul
            li #[strong RCTR] (Run Control Header)
            li #[strong MODH] (Modules Header)
            li #[strong * EVEH] (Event Header)
            li #[strong * ADDH] (Additional Data Header)
            li #[strong * ACQC] (Acquisition Header)
            li #[strong * One ACQC for each channel in the DAQ]
          t
            | #[strong *] Repeated for each event

        section
          name Index Files
          t
            | As the raw files, the index files contain information concerning the run and the
            | channels configuration but in addition they contain also the beam info, the slow
            | parameters and the position of the Event Header in the raw files. These files are
            | written at the end of the run by the application server.
          t
            | The name of the CASTOR index files is formed like this:
          t
            em /castor/cern.ch/ntof/#[strong YEAR]/#[strong EAR]/#[strong EXP]/#[strong XXXXXX]/stream0/run
              | #[strong XXXXXX].idx.finished
          t where:
          ul
            li #[strong YEAR] Year of the start of the run on four digit
            li #[strong EAR] Experimental area (ear1 or ear2)
            li #[strong EXP] Experiment name
            li #[strong XXXXXX] is the run number

          t The internal organization of the file:
          ul
            li #[strong RCTR] (Run Control Header)
            li #[strong MODH] (Modules Header)
            li #[strong INDX] (Index Header)
            li #[strong * EVEH] (Event Header)
            li #[strong * ADDH] (Additional Data Header)
          t
            | #[strong *] Repeated for each event

    section
      name Headers
      t First, it’s important to keep in mind the following information:
      ul
        li All the headers are formed with the same logic
        li For these files, a word equals four bytes
        li
          | The files are written as binary files (so take care of the
          | format used to write the data to avoid endian issues)
        li Endianness is little endian (Intel)

      t In a header:
      ul
        li
          | The first word is used to write the title of the header as a char.
          | For example, it can be “RCTR”, “MODH”, “EVEH”, “ACQC”, “ADDH”, “SKIP”...
        li The second word is an integer used to define the revision number
        li
          | The third word is used to know if a file has been re-written. So if it has been
          | re-written, the value is 1 and in all the others cases it’s equals to 0.
        li The fourth word is the number of words following word in the header
        li The following words are organized differently for each header

      section
        name Example
        t
        table(align='center')
          name Header Example
          thead
            tr #[th Size in Bytes] #[th Type] #[th Content] #[th Example]
          tbody
            tr #[td 4]  #[td 4 char]             #[td Title]                     #[td RTCR]
            tr #[td 4]  #[td unsigned integer]   #[td Revision number]           #[td 1]
            tr #[td 4]  #[td unsigned integer]   #[td Re-write flag]             #[td 0]
            tr #[td 4]  #[td unsigned integer]   #[td Number of words following] #[td 15]

      section
        name RCTR
        t
         | The RCTR (Run Control Header) structure contains some particular information about a run.
        section
          name Run Number
          t
           | The run number is used to identify a run.
           | Since the version 1, this number is contained between 100 000 and 199 999 for EAR1
           | and between 200 000 and 299 999 for EAR2.
        section
          name Segment Number
          t
           | The run segment number is used to identify the file. This number is incremented at
           | every new written file. This data is only available in CASTOR files. This number starts
           | from 0.
        section
          name Stream Id
          t
           | The stream id is used to define a stream in the run.
           | According the DAQ present in the run, the GUI gives the id 1 to the first, the id 2 to
           | the second ... The stream id 0 used to be reserved for the EACS.
           | As there is only one merge operation, CASTOR files will be with the stream ID set to 1.
        section
          name Experiment Identifier
          t
           | The experiment identifier used to be “NTOF” in the version 0 and can be equal to
           | “EAR1” or “EAR2” in the version 1.
        section
          name Date Of The Start Of Run
          t
           | The date of the start of the run is formed as yyymmdd, where yyy is the number of
           | years since 1900. For example, 1999 corresponds to 99 and 2000 corresponds to 100.
        section
          name Time Of The Start Of Run
          t
           | The time of the start of the run is formed as hhmmss.
        section
          name Number Of Modules In The Stream
          t
           | This parameter is the number of cards in the stream.
        section
          name Number Of Channels In The Stream
          t
           | This parameter is the number of channels in the stream.
        section
          name Total Number Of Streams In The Run
          t
           | This parameter is the number of streams in the run. This should be equal to the “Total
           | number of chassis in the run”
        section
          name Total Number Of Chassis In The Run
          t
           | This parameter is the number of chassis in the run. This should be equal to the “Total
           | number of streams in the run”
        section
          name Total Number Of Modules In The Run
          t
           | This parameter is the number of modules in the run.
        section
          name Number Of Used Channels Per Module
          t
           | This parameter is the number of channels used by module in the stream.
        section
          name Example
          t
          table(align='center')
            name RCTR Example
            thead
              tr #[th Size in Bytes] #[th Type] #[th Content] #[th Example]
            tbody
              tr #[td 4]  #[td 4 char]             #[td Title]                               #[td RTCR]
              tr #[td 4]  #[td unsigned integer]   #[td Revision number]                     #[td 2]
              tr #[td 4]  #[td unsigned integer]   #[td Reserved]                            #[td 0]
              tr #[td 4]  #[td unsigned integer]   #[td Number of words following]           #[td 15]
              tr #[td 4]  #[td unsigned integer]   #[td Run number]                          #[td 100162]
              tr #[td 4]  #[td unsigned integer]   #[td Segment/Event number]                #[td 1]
              tr #[td 4]  #[td unsigned integer]   #[td Stream id]                           #[td 1]
              tr #[td 4]  #[td 4 char]             #[td Experiment identifier]               #[td EAR1]
              tr #[td 4]  #[td unsigned integer]   #[td Date of the start of run]            #[td 1160114 (14 Jan 2016)]
              tr #[td 4]  #[td unsigned integer]   #[td Time of the start of run]            #[td 181856]
              tr #[td 4]  #[td unsigned integer]   #[td Number of modules in the stream]     #[td 4]
              tr #[td 4]  #[td unsigned integer]   #[td Number of channels in the stream]    #[td 8]
              tr #[td 4]  #[td unsigned integer]   #[td Total number of streams in the run]  #[td 8]
              tr #[td 4]  #[td unsigned integer]   #[td Total number of chassis in the run]  #[td 8]
              tr #[td 4]  #[td unsigned integer]   #[td Total number of modules in the run]  #[td 32]
              tr #[td 4]  #[td unsigned integer]   #[td Number of used channels per module]  #[td 2]
              tr #[td 4]  #[td unsigned integer]   #[td Number of used channels per module]  #[td 2]
              tr #[td 4]  #[td unsigned integer]   #[td Number of used channels per module]  #[td 2]
              tr #[td 4]  #[td unsigned integer]   #[td Number of used channels per module]  #[td 2]
              tr #[td(colspan=4) total: 60 + (4 * Number of modules in the stream) Bytes]

      section
        name MODH
        t
          | The MODH (Modules Header) structure contains the configurations for all channels in
          | the run. Each channel contains a list of parameters.
        section
          name Number Of Channels
          t
            | This is the number of channels in the run.
        section
          name Detector Type
          t
            | The type of the detector is stored on four characters and is used to know the detector
            | used for the acquisition.
        section
          name Detector Id
          t
            | This field contains a unique identifier for each detector.
        section
          name Module Type
          t
            | The module type defines the type of card. For example, the type can be “ACQC”
            | (Acqiris), “SPDV” (SP devices)...
        section
          name Channel
          t
            | The id of the channel is defined by the DAQ.
        section
          name Module
          t
            | The id of the module is defined by the DAQ.
        section
          name Chassis
          t
            | The id of the chassis for each DAQ is defined in the system’s configuration files and
            | should not be changed.
        section
          name Stream
          t
            | As the file is outputted by only one computer, the stream id will be 1.
        section
          name Sample Rate
          t
            | The sample rate is the sample frequency (in MHz) of the digitizer.
            | For example, the values, which can be taken by this parameter, are:
          ul
            li 500 or 1000 for ETEP modules
            li 1, 10, 50, 100, 200, 250, 400, 500, 1000 or 2000 for Acqiris DC240
            li 10, 50, 100, 200, 250, 400, 500 or 1000 for Acqiris DC270
            li 10, 50, 100, 200, 250, 400, 500, 1000 or 2000 for Acqiris DC282
            li 14.0625, 28.125, 56.25, 112.5, 225, 450, 900 or 1800 for SPDevice (ADQ412)
        section
          name Sample Size
          t
            | The sample size is the amount of data (in kSamples) acquired before zero suppression.
        section
          name Full Scale
          t
            | The full scale is the input range expressed in mV.
        section
          name Delay Time
          t
            | The delay time specifies the length of time from the trigger event to the first point in
            | the waveform record. If the value is positive, the first point in the waveform record
            | occurs after the trigger event. If the value is negative, the first point in the waveform
            | record occurs before the trigger event.
            | The unit is nanosecond.
        section
          name Threshold
          t
            | Threshold is used for the zero suppression and is given in ADC value in the version 0
            | and the version 2 and in mV in the version 1.
            | The ADC range depends of the card type. For example:
          ul
            li for the Acquiris DC240 and DC270, it’s 2#[sup 8]
            li for the Acquiris DC282, it’s 2#[sup 16]
            li for the SPDevice (ADQ412), it’s 2#[sup 12]
          t The value in millivolts is calculated like that:
          t
            em U = threshold ADC * (full scale in millivolts / ADC range) - offset
        section
          name Edge Type
          t
            | Edge type specifies whether the part of the pulse below or above the threshold is
            | expected. If set to 0, the part below is expected, as needed for negative pulses.
            | In the version 0, the values were 0 and 1 respectively for negative and positive, in the
            | next version the negative value has been replaced by -1.
        section
          name Offset
          t
            | The offset is given in mV.
        section
          name Presample
          t
            | The pre-sample is the number of samples kept before a threshold crossing.
            | For the ETEP cards, this value had to be a multiple of 16, the values allowed were
            | 0, 16, 32, 48 ... 2032.
        section
          name Postsample
          t
            | The post-sample is the number of samples kept after a threshold crossing if the pulse
            | doesn’t cross the threshold again during the period.
            | For the ETEP cards, this value had to be a multiple of 16, the values allowed were
            | 0, 16, 32, 48 ... 4080.
        section
          name Clock State
          t
            | Clock state is a four character value specifying the use of an internal or external clock.
            | Allowed values are 'INTC' or 'EXTC' corresponding to internal or external clock.
        section
          name Zero Suppression Start
          t
            | This parameter allows to postpone the start of the zero suppression algorithm.
        section
          name Zero Suppression Master Detector Type
          t
            | This parameter is used to define the detector type of the master for the second level
            | of the zero suppression algorithm. If it’s blank, it means that this detector is a master.
        section
          name Zero Suppression Master Detector Id
          t
            | This parameter is used to define the detector ID of the master for the second level of
            | the zero suppression algorithm.
        section
          name Reserved
          t
            | Few bytes are reserved for future updates.


        section
          name Example
          t
          table(align='center')
            name MODH Example
            thead
              tr #[th Size in Bytes] #[th Type] #[th Content] #[th Example]
            tbody
              tr #[td 4]  #[td 4 char]              #[td Title]                             #[td MODH]
              tr #[td 4]  #[td unsigned integer]    #[td Revision number]                   #[td 4]
              tr #[td 4]  #[td unsigned integer]    #[td Reserved]                          #[td 0]
              tr #[td 4]  #[td unsigned integer]    #[td Number of words following]         #[td 45]
              tr #[td 4]  #[td unsigned integer]    #[td Number of channels]                #[td 2]
              tr #[td(colspan=4)]
              tr #[td 4]  #[td 4 char]              #[td Detector type]                     #[td BAF2]
              tr #[td 4]  #[td unsigned integer]    #[td Detector id]                       #[td 0]
              tr #[td 4]  #[td 4 char]              #[td Module type]                       #[td ACQC]
              tr #[td 1]  #[td unsigned integer]    #[td Channel]                           #[td 1]
              tr #[td 1]  #[td unsigned integer]    #[td Module]                            #[td 1]
              tr #[td 1]  #[td unsigned integer]    #[td Chassis]                           #[td 1]
              tr #[td 1]  #[td unsigned integer]    #[td Stream]                            #[td 1]
              tr #[td 4]  #[td float]               #[td Sample rate (MS/s)]                #[td 500]
              tr #[td 4]  #[td unsigned integer]    #[td Sample size (kS)]             #[td 8000]
              tr #[td 4]  #[td float]               #[td Full scale (mV)]                   #[td 100]
              tr #[td 4]  #[td integer]             #[td Delay time (S as in Samples)]              #[td 0]
              tr #[td 4]  #[td integer]             #[td Threshold]                         #[td 130]
              tr #[td 4]  #[td integer]             #[td Falling edge/Rising edge]          #[td 0]
              tr #[td 4]  #[td float]               #[td Offset (mV)]                       #[td 0]
              tr #[td 4]  #[td unsigned integer]    #[td Pre-sample (S)]              #[td 128]
              tr #[td 4]  #[td unsigned integer]    #[td Post-sample (S)]             #[td 512]
              tr #[td 4]  #[td 4 char]              #[td Clock state]                       #[td INTC]
              tr #[td 4]  #[td unsigned integer]    #[td Zero suppr. start]                 #[td 0]
              tr #[td 4]  #[td 4 char]              #[td Zero suppr. master detector type]  #[td ]
              tr #[td 4]  #[td unsigned integer]    #[td Zero suppr. master detector id]    #[td 0]
              tr #[td 20] #[td ]                    #[td Reserved for future use]           #[td 0]
              tr #[td(colspan=4)]
              tr #[td 4]  #[td 4 char]              #[td Detector type]                     #[td BAF2]
              tr #[td 4]  #[td unsigned integer]    #[td Detector id]                       #[td 1]
              tr #[td 4]  #[td 4 char]              #[td Module type]                       #[td ACQC]
              tr #[td 1]  #[td unsigned integer]    #[td Channel]                           #[td 2]
              tr #[td 1]  #[td unsigned integer]    #[td Module]                            #[td 1]
              tr #[td 1]  #[td unsigned integer]    #[td Chassis]                           #[td 1]
              tr #[td 1]  #[td unsigned integer]    #[td Stream]                            #[td 1]
              tr #[td 4]  #[td float]               #[td Sample rate (MS/s)]                #[td 500]
              tr #[td 4]  #[td unsigned integer]    #[td Sample size (kSample)]             #[td 8000]
              tr #[td 4]  #[td float]               #[td Full scale (mV)]                   #[td 200]
              tr #[td 4]  #[td unsigned integer]    #[td Delay time (samples)]              #[td 0]
              tr #[td 4]  #[td unsigned integer]    #[td Threshold]                         #[td 130]
              tr #[td 4]  #[td unsigned integer]    #[td Falling edge/Rising edge]          #[td 0]
              tr #[td 4]  #[td float]               #[td Offset (mV)]                       #[td 0]
              tr #[td 4]  #[td unsigned integer]    #[td Pre-sample (samples)]              #[td 128]
              tr #[td 4]  #[td unsigned integer]    #[td Post-sample (samples)]             #[td 512]
              tr #[td 4]  #[td 4 char]              #[td Clock state]                       #[td INTC]
              tr #[td 4]  #[td unsigned integer]    #[td Zero suppr. start]                 #[td 0]
              tr #[td 4]  #[td 4 char]              #[td Zero suppr. master detector type]  #[td BAF2]
              tr #[td 4]  #[td unsigned integer]    #[td Zero suppr. master detector id]    #[td 0]
              tr #[td 20] #[td ]                    #[td Reserved for future use]           #[td 0]
              tr #[td(colspan=4) total: 20 + (88 * Number of channels) Bytes]

      section
        name EVEH
        t
          | The EVEH (Event Header) structure contains the timestamp of the event and the
          | identification numbers for the event and for the run. It’s written once for each event,
          | in both, raw and index, files.
          | This header is generated by the EACS and published over DIM for the DAQs.
        section
          name Size Of Event In Words
          t
            | The size of the event in words is the size of all headers wrote in the file and related to
            | this event. This value is equal to the number of words between an Event header and
            | the next Event header in the file.
            | More precisely, for the raw files, this size is calculated by adding the size of each
            | Acquisition header with the size of the Event header and with the size of the Additional
            | header. For the index files, it’s calculated by adding the size of the Event header to
            | the size of the Additional header.
        section
          name Event Number
          t
            | The event number corresponds to the number of validated triggers since the start of the run.
        section
          name Run Number
          t
            | The run number is used to identify a run.
            | Since the version 1, this number is contains between 100000 and 199999 for EAR1
            | and between 200000 and 299999 for EAR2 (Since 2015, numbers between 0 and
            | 99999 is reserved for development usage).
            | This run number must be the same as the run number in the Run control header.
        section
          name Event Time
          t
            | The time when beam is injected into PS formed as hhmmss (cycle stamp).
        section
          name Event Date
          t
            | The date of the trigger is formed as yyymmdd, where yyy is the number of years since
            | 1900. For example, 1999 corresponds to 99 and 2000 corresponds to 100.
        section
          name Extra Empty Line
          t
            | In order to align the data in the memory, an extra line has been added and will
            | contain the value “0”.
        section
          name Computer Time Stamp
          t
            | The computer time stamp is the hardware time when this event was received by the
            | computer. It’s encoded as the number of nanoseconds since the first of January 1970
            | (Epoch UTC).
        section
          name Bct Time Stamp
          t
            | The timestamp is the time when the BCT acquisition was performed.
            | The timestamp is encoded as the number of nanoseconds since the first of January
            | 1970 (Epoch UTC).
        section
          name Beam Intensity
          t
            | The beam intensity is given by the BCT 468 and is the number of protons in the trigger.
        section
          name Beam Type
          t
            | The beam type is encoded as an unsigned integer.
            | There is three different types for the beam:
          ul
            li [1] CALIBRATION: The beam is simulated, there no beam from the PS
            li [2] PRIMARY: The beam comes from the PS and it’s dedicated to n_TOF
            li [3] PARASITIC: The beam comes from the PS but it’s accelerated in shadow of another user.
        section
          name Example
          t
          table(align='center')
            name EVEH Example
            thead
              tr #[th Size in Bytes] #[th Type] #[th Content] #[th Example]
            tbody
              tr #[td 4]  #[td 4 char]              #[td Title]                                         #[td EVEH]
              tr #[td 4]  #[td unsigned integer]    #[td Revision number]                               #[td 0]
              tr #[td 4]  #[td unsigned integer]    #[td Reserved]                                      #[td 0]
              tr #[td 4]  #[td unsigned integer]    #[td Number of words following]                     #[td 12]
              tr #[td 4]  #[td unsigned integer]    #[td Size of event in words]                        #[td 14358]
              tr #[td 4]  #[td unsigned integer]    #[td Event number]                                  #[td 1]
              tr #[td 4]  #[td unsigned integer]    #[td Run number]                                    #[td 3]
              tr #[td 4]  #[td unsigned integer]    #[td Event time]                                    #[td 181955]
              tr #[td 4]  #[td unsigned integer]    #[td Event date]                                    #[td 1150816]
              tr #[td 4]  #[td unsigned integer]    #[td Extra empty line]                              #[td 0]
              tr #[td 8]  #[td double]              #[td Computer time stamp (UTC ns since EPOCH)]      #[td 14322169495E+8]
              tr #[td 8]  #[td double]              #[td BCT readout time stamp (UTC ns since EPOCH)]   #[td 14322169495E+8]
              tr #[td 4]  #[td float]               #[td BCT.468 Beam intensity]                        #[td 6.12E+12]
              tr #[td 4]  #[td unsigned integer]    #[td Beam type]                                     #[td 2]
              tr #[td(colspan=4) total: 64 Bytes]

      section
        name ACQC
        t
          | The ACQC (Acquisition Header) structure contains all the data of a pulse took by a
          | digitizer after the zero skipping algorithm. It’s written once for each channel and are
          | present only in the raw files.
          | This header is generated directly by the DAQ software.
        section
          name Number Of Words Following
          t
            | Because the length of pulses is dynamic, the number of words following is complex to calculate.
            | The method to compute the number of words is:
          t
            em "Size of “Detector Type” + Size of “Detector Id” + Size of “Channel” + Size of “Module”
              | + Size of “Chassis” + Size of “Stream” + (*) Size of “Time stamp” + (*) Size of “Length of the pulse”
              | + (*) [Length of the pulse / Size of “Data”]
          t (*) for each pulse.
        section
          name Detector Type
          t
            | The type of the detector is stored on four characters and is used to know the detector
            | associated with this channel.
            | It must be the same in the Module Header.
        section
          name Detector Id
          t
            | In the case where there is more than one detector of the same type, this id allows to
            | distinguish them. It must be the same in the Module Header.
        section
          name Channel
          t
            | The id of the channel is defined by the DAQ. It must be the same in the Module Header.
        section
          name Module
          t
            | The id of the module is defined by the DAQ. It must be the same in the Module Header.
        section
          name Chassis
          t
            | The id of the chassis is defined by the DAQ. It must be the same in the Module Header.
        section
          name Stream
          t
            | The id of the stream is defined by the GUI. It starts from 1 because the 0 is reserved
            | for the EACS. It must be the same in the Module Header.
        section
          name Timestamp
          t
            | The timestamp is given in samples and specifies the position where the signal crosses
            | the threshold.
        section
          name Length Of The Pulse
          t
            | The length is given in samples and specifies the complete length of the pulse including
            | the pre-sample and post-sample sizes.
        section
          name Data
          t
            | The data has been stored as an unsigned integer of 8 bits in the first versions. In the
            | actual version the data is stored on 16 bits.
            | For example, the data range depends of the type of the card:
          ul
            li For the ACQC DC240 and DC 270 the data can take a value between -128 and 127
            li For the ACQC DC282 the data can take a value between -32768 and 32767
            li For the SPDevice ADQ412 the data can take a value between -2048 and 2047

        section
          name Example
          t
          table(align='center')
            name ACQC Example with two pulses
            thead
              tr #[th Size in Bytes] #[th Type] #[th Content] #[th Example]
            tbody
              tr #[td 4]  #[td 4 char]            #[td Title]                       #[td ACQC]
              tr #[td 4]  #[td unsigned integer]  #[td Revision number]             #[td 1]
              tr #[td 4]  #[td unsigned integer]  #[td Reserved]                    #[td 0]
              tr #[td 4]  #[td unsigned integer]  #[td Number of words following]   #[td 673]
              tr #[td 4]  #[td 4 char]            #[td Detector type]               #[td BAF2]
              tr #[td 4]  #[td unsigned integer]  #[td Detector id]                 #[td 0]
              tr #[td 1]  #[td unsigned integer]  #[td Channel]                     #[td 1]
              tr #[td 1]  #[td unsigned integer]  #[td Module]                      #[td 1]
              tr #[td 1]  #[td unsigned integer]  #[td Chassis]                     #[td 1]
              tr #[td 1]  #[td unsigned integer]  #[td Stream]                      #[td 1]
              tr #[td(colspan=4)]
              tr #[td 8]  #[td long unsigned integer]   #[td Timestamp]             #[td 6]
              tr #[td 8]  #[td long unsigned integer]   #[td Length of the pulse]   #[td 636]
              tr #[td 2]  #[td short unsigned integer]  #[td Data]                  #[td 116]
              tr #[td ]   #[td ]                        #[td 635 * Data]            #[td ]
              tr #[td(colspan=4)]
              tr #[td 8]  #[td long unsigned integer]   #[td Timestamp]             #[td 2123]
              tr #[td 8]  #[td long unsigned integer]   #[td Length of the pulse]   #[td 688]
              tr #[td 2]  #[td short unsigned integer]  #[td Data]                  #[td 119]
              tr #[td ]   #[td ]                        #[td 687 * Data]            #[td ]
              tr #[td(colspan=4) total: 28 + ((Number of Words following - 3) * 4) Bytes]

      section
        name ADDH
        t
          | The ADDH (Additional Data Header) structure contains all additional data useful for
          | n_TOF analysis. It’s designed to be a dynamic structure, so adding/removing a data is
          | easy.
        section
          name Name
          t
            | The name is an array of characters containing the name of the field. It has a fixed
            | length of 64 bytes (null terminated string).
        section
          name Type
          t
            | The type is an enumeration of supported scalar data-types:
          ul
            li [0] CHAR
            li [1] INT
            li [2] INT64
            li [3] FLOAT
            li [4] DOUBLE
          t
            | As char and short data-types are less than one word long, the value can be filled with
            | padding to have a data length multiple of 4 bytes.
        section
          name Repetition
          t
            | The repetition is used to support arrays of data. It represents the length of the array.
        section
          name Value
          t
            | The value contains the data store of this field.
        section
          name Example
          t
          table(align='center')
            name ADDH Example
            thead
              tr #[th Size in Bytes] #[th Type] #[th Content] #[th Example]
            tbody
              tr #[td 4]  #[td 4 char]                  #[td Title]                       #[td ADDH]
              tr #[td 4]  #[td unsigned integer]        #[td Revision number]             #[td 0]
              tr #[td 4]  #[td unsigned integer]        #[td Reserved]                    #[td 0]
              tr #[td 4]  #[td unsigned integer]        #[td Number of words following]   #[td 38]
              tr
                td(colspan=4)
              tr #[td 64] #[td char]                    #[td Name]                        #[td BCT.468.TOF]
              tr #[td 4]  #[td unsigned integer (enum)] #[td Data-type]                   #[td 3]
              tr #[td 4]  #[td unsigned integer]        #[td Repetition factor]           #[td 1]
              tr #[td 4]  #[td float]                   #[td Value]                       #[td 5E12]
              tr
                td(colspan=4)
              tr #[td 64] #[td char]                    #[td Name]                        #[td EVENT_USER]
              tr #[td 4]  #[td unsigned integer (enum)] #[td Data-type]                   #[td 0]
              tr #[td 4]  #[td unsigned integer]        #[td Repetition factor]           #[td 4]
              tr #[td 4]  #[td char]                    #[td Value]                       #[td EAST]

      section
        name INDX
        t
          | The INDX (Index Header) structure contains the file stream, the file segment number
          | and the position of the EVEH into the CASTOR raw data file.
        section
          name Stream Number
          t
            | The stream id is used to define a stream in the run.
            | According the DAQ present in the run, the GUI gives the id 1 to the first, the id 2 to
            | the second ... The stream id 0 used to be reserved for the EACS.
            | Since 2016, as there is only one merge operation, CASTOR files will be with the
            | stream ID set to 1.
        section
          name Segment Number
          t
            | The segment number give the number of the file containing the related event.
        section
          name Validated Number
          t
            | The event number corresponds to the number of validated triggers since the start of the run.
        section
          name Trigger Number
          t
            | The event number corresponds to the number of triggers send from the timing
            | machine since the start of the run.
        section
          name Event File Offset
          t
            | This field give the position of the related EVEH into the CASTOR raw file in bytes. It
            | can be used to jump directly to the corresponding event.
        section
          name Example
          t
          table(align='center')
            name INDX Example
            thead
              tr #[th Size in Bytes] #[th Type] #[th Content] #[th Example]
            tbody
              tr #[td 4]   #[td 4 char]                 #[td Title]                       #[td INDX]
              tr #[td 4]   #[td unsigned integer]       #[td Revision number]             #[td 1]
              tr #[td 4]   #[td unsigned integer]       #[td Reserved]                    #[td 0]
              tr #[td 4]   #[td unsigned integer]       #[td Number of words following]   #[td 12]
              tr #[td(colspan=4)]
              tr #[td 4]   #[td unsigned integer]       #[td Stream number]               #[td 1]
              tr #[td 4]   #[td unsigned integer]       #[td Segment number]              #[td 3]
              tr #[td 4]   #[td unsigned integer]       #[td Validated number]            #[td 56]
              tr #[td 4]   #[td unsigned integer]       #[td Trigger number]              #[td 57]
              tr #[td 8]   #[td unsigned long integer]  #[td Event file offset]           #[td 512054]
              tr #[td(colspan=4)]
              tr #[td 4]   #[td unsigned integer]       #[td Stream number]               #[td 1]
              tr #[td 4]   #[td unsigned integer]       #[td Segment number]              #[td 3]
              tr #[td 4]   #[td unsigned integer]       #[td Event number]                #[td 57]
              tr #[td 4]   #[td unsigned integer]       #[td Trigger number]              #[td 58]
              tr #[td 8]   #[td unsigned long integer]  #[td Event file offset]           #[td 554850]
              tr #[td(colspan=4) total: 16 + (24 * event count) Bytes]


      section
        name SKIP
        t
          | The SKIP header is used to tell the software to ignore some bytes into the current file.
          | It’s only used internally on DAQ local files and will not be written on CASTOR.
        section
          name Start
          t
            | The start offset is used to ignore a number of bytes in the actual file starting from the
            | beginning of the file.
        section
          name End
          t
            | The end offset is used to ignore the complete rest of bytes in the file starting from the
            | beginning of the file. It goal is to remove zero byte padding added for DAQ writing optimization.
        section
          name Example
          t
          table(align='center')
            name SKIP Example
            thead
              tr #[th Size in Bytes] #[th Type] #[th Content] #[th Example]
            tbody
              tr #[td 4]   #[td 4 char]                 #[td Title]                         #[td SKIP]
              tr #[td 4]   #[td unsigned integer]       #[td Revision number]               #[td 0]
              tr #[td 4]   #[td unsigned integer]       #[td Reserved]                      #[td 0]
              tr #[td 4]   #[td unsigned integer]       #[td Number of words following]     #[td 4]
              tr #[td 8]   #[td long unsigned integer]  #[td Start]                         #[td 512]
              tr #[td 8]   #[td long unsigned integer]  #[td End]                           #[td 524192]

    // section
      name Contributors
      // Optional section to mention contributors


  back

    references
      name References
      references
        name Normative References
        | &rfc2119;

      // references
        name Informative References

    section
      name Change Log
      dl
        dt 01 - 27/05/2015
        dd Initial Release
        dt 02 - 16/01/2016
        dd Format adapted for the merger
        dt 03 - 14/06/2016
        dd Second level zero suppression parameters added to the MODH
        dt 04 - 14/01/2020
        dd Migration of this document to RFC standard

    // section
      name Open Issues
      ul
        li Work in progress
